
IncludeScript("murdermystery/artifact_system.nut")
IncludeScript("murdermystery/roles/Bystanders.nut")
IncludeScript("murdermystery/roles/Murderers.nut")
IncludeScript("murdermystery/roles/Sheriffs.nut")
::droppedgun_check_radius 	<- 110
::PlayersPerSpecialRole 	<- 6
::murderers 				<- [] //old remove once passive system is finished


::MurdererRoleText 	<- function(Target, ClassName) {
	local gametext = SpawnEntityFromTable("game_text",{
		 		message 	= "You are a Murderer", 
		 		x 			= -1, 
		 		y 			= 0.15,
		 		holdtime 	= 5,
		 		channel 	= 1,
		 		fadein 		= 1,
		 		fadeout 	= 1.5,
		 		color 		= "200 60 60",
		 		color2 		= "240 110 0",
				channel 	= 5,
		 		})
	EntFireByHandle(gametext, "Display", "", 0, Target, Target)
	EntFireByHandle(gametext, "Kill", "", 10, Target, Target)

	local classtext = SpawnEntityFromTable("game_text",{
		 		message 	= "Your Class is " + ClassName, 
		 		x 			= -1, 
		 		y 			= 0.18,
		 		holdtime 	= 5,
		 		channel 	= 1,
		 		fadein 		= 1,
		 		fadeout 	= 1.5,
		 		color 		= "150 150 150",
		 		color2 		= "240 110 0",
				channel 	= 6,
		 		})
	EntFireByHandle(classtext, "Display", "", 0, Target, Target)
	EntFireByHandle(classtext, "Kill", "", 10, Target, Target)
}
::ChargeDisplay <- function (Target, X_pos, Y_pos, Msg, channelNum) {
	local gametext = SpawnEntityFromTable("game_text",{
		 		message 	= Msg, 
		 		x 			= X_pos, 
		 		y 			= Y_pos,
		 		holdtime 	= 60,
		 		channel 	= 1,
		 		fadein 		= 0,
		 		fadeout 	= 5,
		 		color 		= "255 255 255",
		 		color2 		= "0 0 0",
				channel 	= channelNum,
		 		})
	EntFireByHandle(gametext, "Display", "", 0, Target, Target)
	EntFireByHandle(gametext, "Kill", "", 1, Target, Target)
}
::MurdererRolesList 		<- ["DefaultMurdererClass", "DefaultMurdererClass", "DefaultMurdererClass"]
::StartRoundConvars 		<- function() {
	Convars.SetValue("mp_respawnwavetime", 	999)
	Convars.SetValue("tf_gravetalk", 		0)
}
::EndRoundConvars 			<- function() {
	Convars.SetValue("mp_respawnwavetime", 	1)
	Convars.SetValue("tf_gravetalk", 		1)
}
::SpawnSheriffGun <- function (GunModel, GunScale, GunOrigin, GunAngles) {
	SpawnEntityFromTable("prop_physics_override",{
				targetname  = "dropped_gun",
				Model       = GunModel,
				solid       = 6,
				modelscale 	= GunScale,
				origin      = GunOrigin,
				angles      = GunAngles,
				vscripts    = "murdermystery/RoleController.nut",
				thinkfunction = "droppedgunthink",
				spawnflags = 4,
			}
		)
}


playerlist <- []
//gamemode roles and role asignment
function StartMurderMysteryRound(){
	StartRoundConvars()
	ClientPrint(null, 3, "\x07FFFF76   THE ROUND HAS STARTED.")
	ClientPrint(null, 3, "\x07E10000murderers\x07FFFFFF must kill all\x0700D500 bystanders\x07FFFFFF and\x070000F0 sheriffs\x07FFFFFF to win,")
	ClientPrint(null, 3, "\x0700D500bystanders\x07FFFFFF must survive and find artifacts( sapper gibs) to aquire a gun")
	ClientPrint(null, 3, "\x070000F0sheriffs\x07FFFFFF must protect the\x0700D500 bystanders\x07FFFFFF by shooting the\x07E10000 murderers")
	ClientPrint(null, 3, "\x07a4a4a4 (the living cannot hear the regrets of the dead)")
	
	//find, save and reset all player important/bystander related stats
	for (local i = 1; i <= Constants.Server.MAX_PLAYERS; i++){
    	local player = PlayerInstanceFromIndex(i)
    	if (player == null) continue
		playerlist.append(player)
		player.ValidateScriptScope()
		player.GetScriptScope().MyPartCount <- 0
	}
	
	artifact()
	
	MurdererList.clear()
	MurdererList_Persist.clear()
	local playercount = playerlist.len()
	local GiveSpecialRoles = function () {
		//assign 1 murderer (add role randomization/selection later)
		if (playerlist.len() <= 0) {return}
		local Murderer 	= playerlist.remove(RandomInt(0, playerlist.len()-1))
		local UserID 	= GetPlayerUserID(Murderer)
		AgentSpy(Murderer)
		MurdererList.append(UserID)
		MurdererList_Persist.append(UserID)
		BystanderList.remove(BystanderList.find(UserID))
		//assign 1 Sheriff (add role randomization/selection later)
		if (playerlist.len() <= 0) {return}
		local Sheriff = playerlist.remove(RandomInt(0, playerlist.len()-1))
		Marshal(Sheriff)
	}
	GiveSpecialRoles()
	if (playercount >= 2) {
		while(playercount >= PlayersPerSpecialRole){
			GiveSpecialRoles()
			playercount = playercount - PlayersPerSpecialRole
		}
	}
	while(playerlist.len() >= 1){//bystanders
		NitWit(playerlist.pop())
	}
}

//dropped gun think script
const RETHINK_TIME = 1
function droppedgunthink(){
	local nearbyplayer 		= Entities.FindByClassnameNearest("player", self.GetOrigin(), droppedgun_check_radius)
	local nearbyplayergun 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
	local nearbyplayerknife = NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)

	//gives bystanders gun
	if (nearbyplayer != null) {
		nearbyplayer.ValidateScriptScope()
		if (nearbyplayer.GetScriptScope().MyRole == "bystander") {
			Marshal(nearbyplayer)
			self.Kill()
		}
	}
    return RETHINK_TIME
}
