::GiveWeapon <- function(Index, viewmodel, ClassName, Player, Slot) {
	local model = PrecacheModel(viewmodel)
    local weapon = Entities.CreateByClassname(ClassName)
	NetProps.SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", Index)
    NetProps.SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true)
    NetProps.SetPropBool(weapon, "m_bValidatedAttachedEntity", true)
    NetProps.SetPropInt(weapon, "m_nModelIndex", model)
    weapon.SetTeam(Player.GetTeam())
	weapon.DispatchSpawn()
    NetProps.SetPropEntityArray(Player, "m_hMyWeapons", weapon, Slot)
	Player.Weapon_Equip(weapon)
	
}
::MurdererRoleText 	<- function(Target, ClassName) {
	local gametext = SpawnEntityFromTable("game_text",{
		 		message 	= "You are a Murderer", 
		 		x 			= -1, 
		 		y 			= 0.15,
		 		holdtime 	= 5,
		 		channel 	= 1,
		 		fadein 		= 1,
		 		fadeout 	= 1.5,
		 		color 		= "200 60 60",
		 		color2 		= "240 110 0",
				channel 	= 5,
		 		})
	EntFireByHandle(gametext, "Display", "", 0, Target, Target)
	EntFireByHandle(gametext, "Kill", "", 10, Target, Target)

	local classtext = SpawnEntityFromTable("game_text",{
		 		message 	= "Your Class is " + ClassName, 
		 		x 			= -1, 
		 		y 			= 0.18,
		 		holdtime 	= 5,
		 		channel 	= 1,
		 		fadein 		= 1,
		 		fadeout 	= 1.5,
		 		color 		= "150 150 150",
		 		color2 		= "240 110 0",
				channel 	= 6,
		 		})
	EntFireByHandle(classtext, "Display", "", 0, Target, Target)
	EntFireByHandle(classtext, "Kill", "", 10, Target, Target)
}
::MurdererColorSwapper <- function(Target, ...) {
	local FailCondition = false
	if (vargv.len() >= 1) {FailCondition = vargv[0]}
	if (Target == null) {return}
	if (Target.IsFakeClient() == true) {}
	if (NetProps.GetPropBool(Target, "m_bForcedSkin") != true) {
			NetProps.SetPropBool(Target, "m_bForcedSkin", true)
		}
	if (Target.GetActiveWeapon() != null) {
		if (Target.GetActiveWeapon().GetClassname() == "tf_weapon_builder" && FailCondition == false || Target.GetActiveWeapon().GetClassname() == "tf_weapon_sapper" && FailCondition == false ) {
			NetProps.SetPropInt(Target, "m_nForcedSkin", 0)
			local murder_cosmetic = null
			while(murder_cosmetic = Entities.FindByClassname(murder_cosmetic, "tf_wearable")){
				if (murder_cosmetic.GetOwner() == Target){
				murder_cosmetic.SetTeam(2)
				}
			}
		}
		else {
			NetProps.SetPropInt(Target, "m_nForcedSkin",1)
			local fake_cosmetic = null
			while(fake_cosmetic = Entities.FindByClassname(fake_cosmetic, "tf_wearable")){
				if (fake_cosmetic.GetOwner() == Target){
					fake_cosmetic.SetTeam(3)
				}
			}
		}
	}
}


const RETHINK_TIME = 0.1
function AgentSpyThink() {
	self.ValidateScriptScope()
	if (self.GetScriptScope().MyCharge <= 99) {self.GetScriptScope().MyCharge = self.GetScriptScope().MyCharge + 1}
	if (GetRoundState() != 4) {AddThinkToEnt(self, null)}
	if (self.GetClassname() == "player") {
		local FailCondition = false
		local buttons = NetProps.GetPropInt(self, "m_nButtons")
		local isPressingReload = buttons & Constants.FButtons.IN_RELOAD
		local isPressingAttack3 = buttons & Constants.FButtons.IN_ATTACK3
		//in Cloak speed increase
		if (self.InCond(4) == true) {
			self.AddCustomAttribute("move speed penalty", 1.4, 0.2)
		}
		 //knife throw
		else if (isPressingReload != 0 && self.GetActiveWeapon().GetClassname() == "tf_weapon_knife" && self.GetScriptScope().MyCharge >= 60) {
			local throwknife = SpawnEntityFromTable("tf_projectile_cleaver", {
    			origin 			= self.EyePosition()+self.EyeAngles().Forward()*100,
    			angles 			= self.EyeAngles(),
			})
			throwknife.SetOwner(self)
			throwknife.ApplyAbsVelocityImpulse(self.EyeAngles().Forward()*self.GetScriptScope().MyCharge*22)
			self.GetScriptScope().MyCharge = 0
			
			local trigger_hurt = SpawnEntityFromTable("trigger_hurt", {
				targetname = "Murderer_Trigger",
				damage = 500,
				damagecap = 500,
				damagemodel = 0,
				damagetype = 128,
				nodmgforce = false,
				origin = throwknife.GetOrigin(),
				spawnflags = 1,
				StartDisabled = 0,
			})
			trigger_hurt.KeyValueFromString("mins", "-5 -5 -5")
			trigger_hurt.KeyValueFromString("maxs", "5 5 5")
			trigger_hurt.KeyValueFromInt("solid", 2)
			trigger_hurt.ValidateScriptScope()
			trigger_hurt.GetScriptScope().OwnerPlayer <- self
			EntFireByHandle(trigger_hurt, "SetParent", "!activator", 0, throwknife, null)
		}
		if (isPressingAttack3 && BystanderList.len() <= 1) {
			foreach (UserID in BystanderList) {
				local Health = self.GetHealth()
				local Player = GetPlayerFromUserID(UserID)
				self.TakeDamageEx(Player, Player, null, Player.GetOrigin(), Player.GetOrigin(), 1, 2)
				self.SetHealth(Health)
			}
		}

		MurdererColorSwapper(self, FailCondition)
	}
	return RETHINK_TIME
}

function AgentSpy(murderer) {
	murderer.ValidateScriptScope()
    murderer.Regenerate(true)
    murderer.GetScriptScope().MyRole 	<- "Murderer"
    murderer.GetScriptScope().MyClass 	<- "AgentSpy"
    murderer.GetScriptScope().MyKills 	<- 0
    murderer.GetScriptScope().MyCharge 	<- 80
	GiveWeapon(4, "models/weapons/w_models/w_knife.mdl", "tf_weapon_knife", murderer, 0)

    //murderers.append(murderer)
    local Slot1 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 0)
    local Slot2 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 1)
    local Slot3 	= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 2)
    local Slot4		= NetProps.GetPropEntityArray(murderer, "m_hMyWeapons", 3)

    Slot1.AddAttribute("cannot disguise", 	1, -1)
    Slot1.AddAttribute("damage penalty", 	3.25, -1)
    Slot1.AddAttribute("silent killer ", 	1, -1)
    //Slot1.AddAttribute("max health additive bonus", -25, 	-1)
    
    murderer.Weapon_Switch(Slot1)
    murderer.SetSpyCloakMeter(100)
    murderer.GetScriptScope().AgentSpyThink <- AgentSpyThink
    AddThinkToEnt(murderer, "AgentSpyThink")
    MurdererRoleText(murderer, "AgentSpyThink")
}