IncludeScript("murdermystery/RoleController.nut")
ClearGameEventCallbacks()
::MurdererList 			<- []
::MurdererList_Persist 	<- []
::BystanderList 		<- []

::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager");
::GetPlayerUserID <- function(player){
    return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex());
}
Player_MIA <- function (UserID,) {
	foreach (user_ID in MurdererList) {
		if (user_ID == UserID) {
			MurdererList.remove(MurdererList.find(UserID))
			if (MurdererList.len() <= 0) {
				EndRound(2)
				return
			}
		}
	}

	foreach (user_ID in BystanderList) {
		if (user_ID == UserID) {
			BystanderList.remove(BystanderList.find(UserID))
			if (BystanderList.len() == 1) {
				//LastPlayerEffect(BystanderList[0])
				return
			}
			else if (BystanderList.len() <= 0) {
				EndRound(3)
				return
			}
		}
	}
}
EndRound <- function (Winner) {
	ClientPrint(null, 3, "Round is Over")
	foreach (user_ID in MurdererList_Persist) {
		local Player = GetPlayerFromUserID(user_ID)
		if (Player == null) {return}
		Player.ForceChangeTeam(3, true)
		Player.ValidateScriptScope()
		ClientPrint(null, 3, "Murderer Killed " + Player.GetScriptScope().MyKills + " Players") // murderer after round kills/scores
	}
	local roundend = SpawnEntityFromTable("game_round_win", {
    	    	        TeamNum         = Winner, // 2 for red, 3 for blue, 1 for spec
    	    	        switch_teams    = 0,
    	    	        force_map_reset = 1,
    	    		}
				)
				EndRoundConvars()
				EntFireByHandle(roundend, "RoundWin", "", 0.3, roundend, roundend)
				//EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
}

function OnGameEvent_player_death(params){
	local UserID 		= params.userid
	local deadplayer 	= GetPlayerFromUserID(UserID)
	//NetProps.SetPropBool(self, "m_bForcedSkin", false)
	AddThinkToEnt(deadplayer, null)
	deadplayer.ValidateScriptScope()
	if (deadplayer.GetScriptScope().MyRole == "Sheriff") {//drop gun
		SpawnSheriffGun("models/weapons/w_models/w_revolver.mdl", 1.2, deadplayer.GetOrigin(), deadplayer.GetAbsAngles())
	}

	Player_MIA(UserID)

	deadplayer.GetScriptScope().MyRole 	<- "spec"
	deadplayer.GetScriptScope().MyClass <- "null"
}

function OnGameEvent_player_activate(par) {
	local UserID = par.userid
	local Player = GetPlayerFromUserID(UserID)
	Player.ValidateScriptScope()
	Player.GetScriptScope().Karma <- 0
	printl("player joined. there karma is " + Player.GetScriptScope().Karma)
}

function OnGameEvent_player_disconnect(par) {
	local UserID 		= par.userid
	Player_MIA(UserID)
}

function OnPostSpawn() {
	Convars.SetValue("mp_friendlyfire", 	1)
	Convars.SetValue("mp_autoteambalance", 	0)
	Convars.SetValue("tf_dropped_weapon_lifetime", 	0)
	Convars.SetValue("sv_alltalk", 			1)
	Convars.SetValue("mp_respawnwavetime", 	1)
	Convars.SetValue("mp_teams_unbalance_limit", 0)
	Convars.SetValue("mp_disable_respawn_times", 0)
 	Convars.SetValue("mp_scrambleteams_auto", 0)
	Convars.SetValue("mp_winlimit", 0)
	Convars.SetValue("mp_maxrounds", 0)
	Convars.SetValue("mp_humans_must_join_team", "red")
	Convars.SetValue("sv_vote_issue_autobalance_allowed", "0")
	Convars.SetValue("sv_vote_issue_scramble_teams_allowed", "0")
}

//force class change
function OnGameEvent_player_spawn(params){
	local UserID 			= params.userid
	local respawnedplayer 	= GetPlayerFromUserID(params.userid)
	respawnedplayer.ValidateScriptScope()
	if (respawnedplayer != null && params.team == 0 ){
		respawnedplayer.GetScriptScope().MyRole 	<- "spec"
		respawnedplayer.GetScriptScope().MyClass 	<- "null"
	}
	else{
		respawnedplayer.ForceChangeTeam(2, true)
		respawnedplayer.SetPlayerClass(8)
		respawnedplayer.SetCustomModel(null) // fixs hitboxs being miss aligned 
		NetProps.SetPropInt(respawnedplayer, "m_nForcedSkin", 0)
		local murder_cosmetic = null
		while(murder_cosmetic = Entities.FindByClassname(murder_cosmetic, "tf_wearable")){
			if (murder_cosmetic.GetOwner() == respawnedplayer){
			murder_cosmetic.SetTeam(2)
			}
		}
		NitWit(respawnedplayer)
		BystanderList.append(UserID)
		respawnedplayer.GetScriptScope().Karma = respawnedplayer.GetScriptScope().Karma + 1
	}
	
}

//killfeed mod
function OnScriptHook_OnTakeDamage(params) {
	params.attacker.ValidateScriptScope()
	params.const_entity.ValidateScriptScope()

	//will use later... manybe
	/*EntFireByHandle(params.const_entity, "BecomeRagdoll", "", 0, self, self)
	NetProps.SetPropInt(params.const_entity, "m_iObserverLastMode", 5);
	local team = NetProps.GetPropInt(params.const_entity, "m_iTeamNum");
	NetProps.SetPropInt(params.const_entity, "m_iTeamNum", 1);
	params.const_entity.DispatchSpawn();
	NetProps.SetPropInt(params.const_entity, "m_iTeamNum", team);*/
	
	if (params.attacker.GetClassname() == "player" && params.const_entity.GetClassname() == "player") {
		if (GetPlayerUserID(params.attacker) != GetPlayerUserID(params.const_entity)) {
			if (params.attacker.GetScriptScope().MyRole == "Sheriff") {
				if (params.const_entity.GetScriptScope().MyRole == "Bystander") {
					params.attacker.TakeDamageEx(params.attacker, params.attacker, params.attacker, params.attacker.GetOrigin(), params.attacker.GetOrigin(), 999, 1);
					params.attacker.GetScriptScope().Karma = params.attacker.GetScriptScope().Karma - 10
				}
				else if (params.const_entity.GetScriptScope().MyRole == "Sheriff") {
					params.damage = params.const_entity.GetHealth() - 1
				}
				//else if (params.const_entity.GetScriptScope().MyRole == "Murderer") {}
			}
			else if (params.attacker.GetScriptScope().MyRole == "Murderer") {
				if (params.const_entity.GetScriptScope().MyRole == "Murderer" && params.damage >= params.const_entity.GetHealth()) {
					params.damage = params.const_entity.GetHealth() - 1
				}
				//else if (params.const_entity.GetScriptScope().MyRole == "Sheriff") {}
				else{
					if (params.damage >= params.const_entity.GetHealth()) {
						params.attacker.GetScriptScope().MyKills = params.attacker.GetScriptScope().MyKills + 1
					}
				}
			}
		}
	}
	else if (params.attacker.GetClassname() == "trigger_hurt" && params.const_entity.GetClassname() == "player") {
		if (params.attacker.GetName().tostring() == "Murderer_Trigger") {
			if (params.const_entity.GetScriptScope().MyRole == "Murderer") {
				if (params.const_entity.GetScriptScope().MyRole == "Murderer" && params.damage >= params.const_entity.GetHealth()) {
					params.damage = params.const_entity.GetHealth() - 1
				}
			}
			else{
				local Oplayer = params.attacker.GetScriptScope().OwnerPlayer
				Oplayer.ValidateScriptScope()
				Oplayer.GetScriptScope().MyKills = Oplayer.GetScriptScope().MyKills + 1
			}
		}
	}
	params.attacker = params.const_entity
}

//commands
function OnGameEvent_player_say(params) {
	local Player = GetPlayerFromUserID(params.userid)
	Player.ValidateScriptScope()
	if (params.text == "!commands") {
		ClientPrint(Player, 3, "\x07ffffffListing GameMode Commands")
		ClientPrint(Player, 3, "\x07ffff00 - \x07ffffff!setclass -(to be implamented)")
		ClientPrint(Player, 3, "\x07ffff00 - \x07ffffff!getclasslist -(to be implamented)")
		ClientPrint(Player, 3, "\x07ffff00 - \x07ffffff!karma")
	}
	else if (params.text == "!setclass*") {
		ClientPrint(Player, 3, "yet to be added")
	}
	else if (params.text == "!getclasslist*") {
		ClientPrint(Player, 3, "yet to be added")
		//if (MurdererRolesList.len() != 0 && params.text == "!getclasslist murderer*") {MurdererRolesList}
	}
	else if (params.text == "!karma") {
		ClientPrint(Player, 3, "your karma level is [" + Player.GetScriptScope().karma + "]")
	}
}

__CollectGameEventCallbacks(this)